pragma solidity ^0.4.17;

contract SimpleDNS {

    struct Record {
        address owner;
        string ipaddr;
    }

    mapping(string => Record) domains;

    function setOwner(string _domain) public {
        require(domains[_domain].owner == address(0x0));
        domains[_domain].owner = msg.sender;
    }

    function setIp(string _domain, string _ipaddr) public {
        require(domains[_domain].owner == msg.sender);
        domains[_domain].ipaddr = _ipaddr;
    }

    function getOwner(string _domain) public view returns(address) {
        return domains[_domain].owner;
    }

    function getIp(string _domain) public view returns(string) {
        return domains[_domain].ipaddr;
    }

}